// (c) 2011 proteino.de (Norbert Schroeder)
// Licence: LGPL 2.1 or above

#include "tollos.h"           // Tollos library

#include <stdlib.h>
#include "system/LPC17xx_system.h"
#include "smalltools.h"
#include "system/LPC17xx_ADC.h"
#include <lcd/TFT-ST7781R.h> 

//#include <stdint.h>
//#include <tollosI2C.h>

////////////// global var begin ///////////////////////////////////////////////
static char buf[11];
////////////// global var end /////////////////////////////////////////////////

//const char buf2[] = {0, 162, 138, 40, 0, 162, 138, 40, 3, 255, 217}; // Flash

uint32_t int2str(uint32_t i){
 uint32_t a,b;
 char buf2[11];
 buf2[10]=0;
 for(a=9;a>=0;a--){
  buf2[a]=i%10+'0';
  if(!(i/=10))break;
 }
 for(b=0;b<10-a;b++){
  buf[b]=buf2[b+a];
 }
 buf[b]=0;
 return buf;
}

int init(void) {		// Tollos-Init, return 0 to start tick() calls, or 1 to halt (power down).
 debugBaud(9600);
 debugf("\n--- ARM booted ---\n--- %s; sample compiled on %s at %s\n", TOLLOS_VERSION,__DATE__, __TIME__);	// Send a string to the host computer terminal
 debugf("--- SYS_Clock        %d MHz\n", sysQuery(SYS_CLOCK));
 debugf("--- Sys_TickTime     %d\n", sysQuery(SYS_TICKTIME));
 debugf("--- Sys_TickMax      %d\n", sysQuery(SYS_TICKMAX));
 debugf("--- Sys_TickLast     %d\n", sysQuery(SYS_TICKLAST));
 debugf("--- Sys_Watchdog     %d\n", sysQuery(SYS_WATCHDOG));
 debugf("--- Sys_StackUsed    %d\n", sysQuery(SYS_STACKUSED));
 debugf("--- Sys_Stacksize    %d\n", sysQuery(SYS_STACKSIZE));
// r=i2cIO(i2cdevice,0,0,0,0);debugf("--- IC Init, Result %i\n",r);
// r=i2cScan(i2cdevice+0,i2cdevice+1);debugf("--- IC Devices attached %i\n",r);
 debugf("--- --- --- --- --- --- --- --- --- --- --- --- --- --- ---\n");
 LEDflash(2);
/*
 ClockRateEOsc(12000000);
 debugBaud(9600);
 debugf("--- SYS_Clock        %d MHz\n", sysQuery(SYS_CLOCK));
*/

 LCD_Init();

//debugf("CLS start");for(uint32_t a=0;a<=0x00FF;a++){LCD_ClrScr(/*a<<8|*/a);/*sysPause(250);*/}debugf("CLS end");
//debugf("PIXEL start");for(uint32_t a=0;a<240;a++)for(uint32_t b=0;b<320;b++){LCD_SetPixel(a,b,0x80FC);/*sysPause(1);*/}debugf("PIXEL end");

 sysSet(SYS_WATCHDOG, 5000);	// Request that the watchdog timer reset the processor if a tick() call takes more than 5 seconds
 return 0;
} // init

  /* --------------------------------------------------------------- */
  /* tick -- repeating tick function                                 */
  /*                                                                 */
  /* This is called once a tick (default 25 Hz) after init() ends.   */
  /* Return 0 to continue tick() calls, or 1 to halt (power down).   */
  /* --------------------------------------------------------------- */
int tick(void) {
 static int ticks=0;         // counter
 static int TouchX,TouchY;
 uint32_t a;
 if(ticks==0){
  LCD_TestScreen(ticks);
 }
 if(ticks==1){
/*  ADC_init(1<<0);
  a=ADC_read();
  ADC_free();
  LCD_String("Touch Y-: ",10,190,1,0xF88F);
  LCD_String(int2str(a),100,190,1,0xF88F);*/
 }else if(ticks==2)TouchX=Touch2wire_ReadX();
 else if(ticks==3)TouchY=Touch2wire_ReadY();
 else if(ticks==4){
/*  ADC_init(1<<3);
  a=ADC_read();
  ADC_free();
  LCD_String("Touch X+: ",10,220,1,0xF88F);
  LCD_String(int2str(a),100,220,1,0xF88F);*/
 }else if(ticks==5){
  ADC_init(1<<5);
  a=ADC_read();
  ADC_free();
  debugf(" %s\n",int2str(a));
  LCD_String("LDR: ",10,180,1,0xF88F);
  LCD_String(int2str(a),100,180,1,0xF88F);
 }
 if((ticks==6)&&(TouchX+TouchY>0)){
  LCD_String("TouchX: ",10,240,1,0xF88F);
  LCD_String(int2str(TouchX),100,240,1,0xFAAF);
  LCD_String("TouchY: ",10,250,1,0xF88F);
  LCD_String(int2str(TouchY),100,250,1,0xFAAF);
 }
 if(ticks==100){	// Change a LED state every second
  ticks=0;
  LEDflash(1);
 }else{
  ticks++;
 }

 return 0;
} // tick
