// unit with some variables and often used functions
// designed for ARM Cortex-M3 from NXP (LPC*)
// (c) 2011 proteino.de (Norbert Schroeder)
// Licence: LGPL 2.1 or above

#ifndef smalltools
#define smalltools

////////////// prototype begin ////////////////////////////////////////////////
void LEDflash(uint32_t a);								// blink the 4 mbed-LEDs
void LEDflash2(uint32_t a);								// blink pin2.1 + pin2.0 (mbed pin25/26)
uint SW_pressed(void);									// switch at p0.16 (mbed p14)
////////////// prototype end //////////////////////////////////////////////////


////////////// LED-Flash begin ////////////////////////////////////////////////
void LEDflash(uint32_t a){				// a*100ms blinken - berschreibt Port1-Defs !!!
 uint32_t p1=(1<<18)|(1<<20)|(1<<21)|(1<<23);				// mbed-LEDs an Port1
 *GPIO1_DIR=p1;
 *GPIO1_MASK=~p1;
 for(uint32_t i=0;i<a;i++){			// Let LED1 blink for 100ms; Bsp. fr PIN statt SET/CLR
  *GPIO1_PIN=p1;					// ledSet(1, LED_ON);
  sysPause(50);
  *GPIO1_PIN=~p1;					// ledSet(1, LED_INVERT);
  sysPause(50);
 }
}

void LEDflash2(uint32_t a){			// pin2.1 + pin2.0 (mbed pin25/26)
 uint32_t p2=(1<<0)|(1<<1);
 *GPIO2_DIR=p2;
 *GPIO2_MASK=~p2;
 for(uint32_t i=0;i<a;i++){
  *GPIO2_PIN=(1<<0);				// LED an pin2.0
  sysPause(25);
  *GPIO2_PIN=(1<<1);				// LED an pin2.1
  sysPause(25);
  *GPIO2_PIN=(1<<1)|(1<<0);			// LEDs an pin2.0 + pin2.1
  sysPause(25);
  *GPIO2_PIN=0;						// LEDs aus
  sysPause(25);
 }
}
////////////// LED-Flash end //////////////////////////////////////////////////


////////////// Switch begin ///////////////////////////////////////////////////
uint SW_pressed(void){				// if switch pressed then return 1 else return 0
 uint p0=(1<<16);
 uint sw;
 *GPIO0_DIR&=~p0;					// switch at p0.16 (mbed p14)
 *GPIO0_MASK=~p0;
 sw=~*GPIO0_PIN;					// der olle Schalter ist bei den obigen Einstellungen lowaktiv und muss per Pull-Down auf Masse gezogen werden
 sw&=p0;
 sw>>=16;
// if(debLevel==3)debugf("%i\n",sw);
 return sw;
}
////////////// Switch end /////////////////////////////////////////////////////

#endif
