// unit with some variables and often used functions
// designed for ARM Cortex-M3 NXP LPC17xx, especially LPC1768 (mbed)
// (c) 2011 proteino.de (Norbert Schroeder)
// Licence: LGPL 2.1 or above

#ifndef _LPC17xx_register_h
#define _LPC17xx_register_h

////////////// Register begin /////////////////////////////////////////////////
//#define GPIO0_DIR	(uint32_t*)(GPIO_BASE + 0x00000000)
//#define GPIO1_DIR	(uint32_t*)(GPIO_BASE + 0x00000020)
volatile uint32_t* GPIO0_DIR = (uint32_t)0x2009C000; 	// LPC_GPIO0+0x00
volatile uint32_t* GPIO0_MASK= (uint32_t)0x2009C010;	// LPC_GPIO0+0x10
volatile uint32_t* GPIO0_PIN = (uint32_t)0x2009C014;	// LPC_GPIO0+0x14
volatile uint32_t* GPIO0_SET = (uint32_t)0x2009C018;	// LPC_GPIO0+0x18
volatile uint32_t* GPIO0_CLR = (uint32_t)0x2009C01C;	// LPC_GPIO0+0x1C
volatile uint32_t* GPIO1_DIR = (uint32_t)0x2009C020;	// LPC_GPIO1+0x00
volatile uint32_t* GPIO1_MASK= (uint32_t)0x2009C030;	// LPC_GPIO1+0x10
volatile uint32_t* GPIO1_PIN = (uint32_t)0x2009C034;	// LPC_GPIO1+0x14
volatile uint32_t* GPIO1_SET = (uint32_t)0x2009C038;	// LPC_GPIO1+0x18
volatile uint32_t* GPIO1_CLR = (uint32_t)0x2009C03C;	// LPC_GPIO1+0x1C
volatile uint32_t* GPIO2_DIR = (uint32_t)0x2009C040;	// LPC_GPIO2+0x00
volatile uint32_t* GPIO2_MASK= (uint32_t)0x2009C050;	// LPC_GPIO2+0x10
volatile uint32_t* GPIO2_PIN = (uint32_t)0x2009C054;	// LPC_GPIO2+0x14
volatile uint32_t* GPIO2_SET = (uint32_t)0x2009C058;	// LPC_GPIO2+0x18
volatile uint32_t* GPIO2_CLR = (uint32_t)0x2009C05C;	// LPC_GPIO2+0x1C
volatile uint32_t* PINSEL0   = (uint32_t)0x4002C000;	// Pin Function Select Register 0 (Port0, Pins 0-15)
volatile uint32_t* PINSEL1	 = (uint32_t)0x4002C004;	// PINSEL1 - Port0 Pins 16-31
volatile uint32_t* PINSEL2	 = (uint32_t)0x4002C008;	// PINSEL2 - Port1 Pins 0-15
volatile uint32_t* PINSEL3   = (uint32_t)0x4002C00C;	// PINSEL3 - Port1 Pins 16-31
volatile uint32_t* PINSEL4   = (uint32_t)0x4002C010;	// PINSEL4 - Port2 Pins 0-15
volatile uint32_t* PINMODE0  = (uint32_t)0x4002C040;	// PINMODE0 - controls pull-up/pull-down resistor configuration for Port 0 pins 0-11,15
volatile uint32_t* PINMODE1  = (uint32_t)0x4002C044;	// Port 0 pins 16 to 26
volatile uint32_t* PINMODE2  = (uint32_t)0x4002C048;	// Port 1 pins 0,1,4,8-10,14,15
volatile uint32_t* PINMODE3  = (uint32_t)0x4002C04C;	// Port 1 pins 16 to 31
volatile uint32_t* PINMODE4  = (uint32_t)0x4002C050;	// Port 2 pins 0 to 13
volatile uint32_t* PINMODE5  = (uint32_t)0x4002C054;	// nicht im Datenblatt, also wohl auch nicht nutzbar - Port 2 pins 16-31	???
volatile uint32_t* PINMODE6  = (uint32_t)0x4002C058;	// nicht im Datenblatt, also wohl auch nicht nutzbar - Port 3 pins 0 to 15	???
volatile uint32_t* PINMODE7  = (uint32_t)0x4002C05C;	// Port 3 pins 25,26
volatile uint32_t* PINMODE9  = (uint32_t)0x4002C064;	// Port 4 pins 28,29
volatile uint32_t* FLASHCFG  = (uint32_t)0x400FC000;	// Flash Accelerator Configuration Register. Controls flash access timing. (page 70)
volatile uint32_t* PCON		 = (uint32_t)0x400FC0C0;	// Power Mode Control register (page 61), Power-saving Bits: 3=BOGD (Brown-Out Global Disable)
volatile uint32_t* PCONP	 = (uint32_t)0x400FC0C4;	// Power Control for Peripherals register, Down: 0-14/16-31, also PCONP=0x00008000; PCGPIO=15 kann meist auch weg
volatile uint32_t* CLKSRCSEL = (uint32_t)0x400FC10C;	// Clock Source Select register (intern/extern/RTC)
volatile uint32_t* PLL0CON	 = (uint32_t)0x400FC080;	// PLL0 Control Register (page 36)
volatile uint32_t* PLL0CFG	 = (uint32_t)0x400FC084;	// PLL0 Configuration Register
volatile uint32_t* PLL0STAT	 = (uint32_t)0x400FC088;	// PLL0 Status Register
volatile uint32_t* PLL0FEED	 = (uint32_t)0x400FC08C;	// PLL0 Feed Register
volatile uint32_t* PLL1CON	 = (uint32_t)0x400FC0A0;	// PLL0 Control Register (page 36)
volatile uint32_t* PLL1CFG	 = (uint32_t)0x400FC0A4;	// PLL0 Configuration Register
volatile uint32_t* PLL1STAT	 = (uint32_t)0x400FC0A8;	// PLL0 Status Register
volatile uint32_t* PLL1FEED	 = (uint32_t)0x400FC0AC;	// PLL0 Feed Register
volatile uint32_t* CCLKCFG	 = (uint32_t)0x400FC104;	// CPU Clock Configuration register
volatile uint32_t* SCR		 = (uint32_t)0xE000ED10;	// System Control Register, for sleep-modes
volatile uint32_t* AD0CR     = (uint32_t)0x40034000;	// A/D 0 Control Register (UserManual 29.5.1)
volatile uint32_t* AD0GDR    = (uint32_t)0x40034004;	// A/D Global Data Register (UserManual 29.5.2)
//volatile uint32_t* PCLKSEL0= (uint32_t)0x400FC1A8;	// Takt fr diverse Komponenten wie ADC, UART, PWM, ...
////////////// Register end ///////////////////////////////////////////////////

#endif